package jp.co.powerbeans.common.db;

import java.util.HashMap;
import java.util.Map;

public final class DBCacheManager {
	private static Map<String, Object> dbcache = new HashMap<String, Object>();

	/**
	 * 条件とソート順を指定して複数件取得
	 * @param cls モデルクラス
	 * @param where 検索条件
	 * @param orderby ソート順
	 * @return 検索結果
	 */
	public static Object[] findBy(Class cls, String where, String orderby) {
		String key = "findBy" + cls + where + orderby;
		Object[] res = (Object[]) getCache(key);
		if (res == null) {
			res = DBManager.findBy(cls, where, orderby);
			registCache(key, res); // TODO clone した方が良いかも
		}
		return res;
	}

	private static void registCache(String key, Object res) {
		dbcache.put(key, res);
	}

	private static Object getCache(String key) {
		return dbcache.get(key);
	}

	public static Object findByPrimaryKey(Class cls, int id) {
		String key = "findByPrimaryKey" + cls + id;
		Object res = getCache(key);
		if (res == null) {
			res = DBManager.findByPrimaryKey(cls, id);
			registCache(key, res); // TODO clone した方が良いかも
		}
		return res;
	}

  public static Object findByPrimaryKey(Class cls, String id) {
    String key = "findByPrimaryKey" + cls + id;
    Object res = getCache(key);
    if (res == null) {
      res = DBManager.findByPrimaryKey(cls, id);
      registCache(key, res); // TODO clone した方が良いかも
    }
    return res;
  }
	public static void clear() {
		dbcache.clear();
	}

	public static Object[] findByAll(Class cls) {
		String key = "findByAll" + cls;
		Object[] res = (Object[]) getCache(key);
		if (res == null) {
			res = DBManager.findByAll(cls);
			registCache(key, res); // TODO clone した方が良いかも
		}
		return res;
	}

}
