package jp.co.powerbeans.common.swt.controldata;

import jp.co.powerbeans.common.swt.ChkConvSwt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Control;

public class PBComboControlData extends ControlDataBase {

	public PBComboControlData(Control[] control) {
		super(control);
	}

	public void setText(String val) {
		Combo combo = getCombo();
		combo.setText(val);
	}

  private Combo getCombo() {
    return (Combo)getControl()[0];
  }

	public String getText() {
		Combo combo = getCombo();
		if ((combo.getStyle() & SWT.READ_ONLY) == 0) {
			// 編集可能な場合は表示テキストをそのまま返す
			return combo.getText();
		} else {
			// 編集不可能な場合
			
			String val = ChkConvSwt.getSelectObjectPK(combo);
			
			if (val == null || val.length() == 0) {
				// 取得できなかった場合はModelではないので表示テキストをそのまま返す
				val = combo.getText();
			}
			return val;
		}
	}

  /* (non-Javadoc)
   * @see jp.co.powerbeans.common.swt.ControlData#getBeanValue()
   */
  public Object getBeanValue() {
    // 選択インデックス+1をIntegerで返す
    // ※IDは1から始まるため
    return Integer.valueOf(getCombo().getSelectionIndex() + 1);
  }

}
