/**
 * WebSukui
 * copyright PowerBEANS Co., Ltd.
 * create date 2006/10/05
 * amonden
 */
package jp.co.powerbeans.websukui.swt;

import java.util.HashMap;
import java.util.Map;

import jp.co.powerbeans.common.Dict;
import jp.co.powerbeans.common.db.DBManager;

import org.eclipse.swt.widgets.Control;

/**
 * PBConfigSwt.
 * 汎用設定画面
 * 
 * @author amonden
 * @create date 2006/10/05
 */
public class PBConfigSwt extends PBSwt {

  /**
   * 設定格納クラス
   */
  private Class masterCls;

  /**
   * 表示コントロール
   */
  private Control[] controls;

  /**
   * 表示コントロール
   */
  private Map<String, Control> contMap;

  /**
   * コンストラクタ
   * @param 対象マスタクラス
   */
  public PBConfigSwt(Class master_cls) {
    this.masterCls = master_cls;
    contMap = new HashMap<String, Control>();
    initialize();
  }

  /**
   * 内部初期化
   */
  private void initialize() {
    createSShell(this.masterCls.getSimpleName(), 400, 400, true);
    setGridLayout(2);
    createItems();
    
    // 現在の設定を取得
    if (DBManager.countByAll(this.masterCls) > 0) {
      Object obj = DBManager.findByPrimaryKey(this.masterCls, 1);
      copyModelToControlMap(obj);
    }
  }

  /**
   * 項目追加
   */
  private void createItems() {

    String[] cols = DictUtil.getEditDisplayRowColumns(this.masterCls);

    // 各項目を表示
    this.controls = new Control[cols.length];
    for (int i = 0; i < cols.length; i++) {
      String col = cols[i];
      addLabel(Dict.trans(col));

      this.controls[i] = addTextBox(col);
      this.contMap.put(col.toUpperCase(), this.controls[i]);
    }
    // カラム名=クラス名+Id の場合は読み取り専用にする
    String pk = (this.masterCls.getSimpleName() + "Id").toUpperCase();
    if (this.contMap.containsKey(pk)) {
      Control c = this.contMap.get(pk);
      c.setEnabled(false);
    }

    addOKCancelButton();
  }

  /* (non-Javadoc)
   * @see jp.co.powerbeans.websukui.swt.PBSwt#cmdOk()
   */
  public void cmdOk() {
    // 保存
    Object obj = copyControlMapToModel(this.masterCls);

    if (DBManager.countByAll(this.masterCls) == 0) {
      DBManager.insert(obj);
    } else {
      DBManager.update(obj);
    }

    super.cmdOk();
  }
}
