/**
 * WebSukui
 * copyright PowerBEANS Co., Ltd.
 * create date 2006/10/05
 * amonden
 */
package jp.co.powerbeans.websukui.swt;

import java.util.HashMap;
import java.util.Map;

import jp.co.powerbeans.common.Dict;
import jp.co.powerbeans.common.db.DBManager;

import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Text;

/**
 * PBMasterEditSwt.
 * マスタ追加、編集汎用画面
 * 
 * @author amonden
 * @create date 2006/10/05
 */
public class PBMasterEditSwt extends PBSwt {

  /**
   * コマンド
   */
  private String cmd;

  /**
   * 対象マスタクラス
   */
  private Class masterCls;

  /**
   * 編集用レコードID
   */
  private int editId;

  /**
   * 表示コントロール
   */
  private Control[] controls;

  /**
   * 表示コントロール
   */
  private Map<String, Control> contMap;

  private String[] cols;

  /**
   * コンストラクタ
   * @param cmd コマンド (add or edit)
   * @param 対象マスタクラス
   */
  public PBMasterEditSwt(String cmd, Class master_cls) {
    this(cmd, master_cls, 0);
  }

  /**
   * コンストラクタ
   * @param cmd コマンド (add or edit)
   * @param 対象マスタクラス
   * @param 編集用レコードID
   */
  public PBMasterEditSwt(String cmd, Class master_cls, int id) {
    this.cmd = cmd;
    this.masterCls = master_cls;
    this.editId = id;
    contMap = new HashMap<String, Control>();
    initialize();
  }

  /**
   * 内部初期化
   */
  private void initialize() {
    // 先にカラム数を取得
    cols = DictUtil.getEditDisplayRowColumns(this.masterCls);
    
    createSShell(this.masterCls.getSimpleName() + cmd.toUpperCase(), 400, 60 + cols.length * 25, true);
    setGridLayout(2);
    createItems();
    
    if ("edit".equals(cmd) && this.editId != 0) {
      // 編集の場合は初期値を取得
      Object obj = DBManager.findByPrimaryKey(this.masterCls, this.editId);
      copyModelToControlMap(obj);
    }
  }

  /**
   * 項目追加
   */
  private void createItems() {

    // 各項目を表示
    this.controls = new Control[cols.length];
    for (int i = 0; i < cols.length; i++) {
      String col = cols[i];
      addLabel(Dict.trans(col));

      this.controls[i] = addControlByType(this.masterCls, col);
      this.contMap.put(col.toUpperCase(), this.controls[i]);
    }
    // カラム名=クラス名+Id の場合は読み取り専用にする
    String pk = (this.masterCls.getSimpleName() + "Id").toUpperCase();
    if (this.contMap.containsKey(pk)) {
      Control c = this.contMap.get(pk);
      c.setEnabled(false);
      // 0 以外の場合は表示
      if (this.editId != 0 && c instanceof Text) {
        ((Text) c).setText("" + c);
      }
    }

    addOKCancelButton();
  }

  /* (non-Javadoc)
   * @see jp.co.powerbeans.websukui.swt.PBSwt#cmdOk()
   */
  public void cmdOk() {
    // 保存
    Object obj = copyControlMapToModel(this.masterCls);

    if ("add".equals(this.cmd)) {
      DBManager.insert(obj);
    } else {
      DBManager.update(obj);
    }

    super.cmdOk();
  }



}
