/**
 * WebSukui
 * create date 2006/10/05
 * amonden
 */
package jp.co.powerbeans.websukui.swt;

import jp.co.powerbeans.common.db.DBCacheManager;
import jp.co.powerbeans.common.db.DBManager;
import jp.co.powerbeans.common.swt.ChkConvSwt;
import jp.co.powerbeans.common.swt.MsgSwt;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;

/**
 * PBMasterMgrSwt. 汎用マスタ管理SWTウィンドウクラス. 直接インスタンス化するため abstract にはしない
 * 
 * @author amonden
 * @create date 2006/10/05
 */
public class PBMasterMgrSwt extends PBSwt {

  private String[] TABLE_COLS = {};

  private String[] TABLE_ROW_COLS = {};

  private int[] TABLE_COL_WIDTHS = {};

  protected Class masterCls;

  private final String title;

  protected Composite comp;

  protected Table table;

  private int[] copyIds;

  private static final String[] MENU_LABELS = { "Edit", "Add", "Del", "Refresh", "Copy", "Paste" };
  private static final char[] MENU_ACC = { 'E', 'A', 'D', 'R', 'C', 'V'};

  private static final String[] MENU_CMDS = { "edit", "add", "del", "update", "copy", "paste" };

  /**
   * コンストラクタ
   * @param master_cls マスタクラス
   */
  public PBMasterMgrSwt(Class master_cls) {
    this(master_cls, master_cls.getSimpleName() + " Manage");
  }

  /**
   * コンストラクタ
   * @param master_cls マスタクラス
   * @param title タイトル
   */
  public PBMasterMgrSwt(Class master_cls, String title) {
    super();
    this.title = title;
    this.masterCls = master_cls;
    createSShell(title, true);

    {
      // 列名を取得. 末尾が hid 以外のフィールドを表示
      this.TABLE_ROW_COLS = DictUtil.getListDisplayRowColumns(master_cls);
      this.TABLE_COLS = DictUtil.convertRowToDisp(TABLE_ROW_COLS);
      TABLE_COL_WIDTHS = new int[this.TABLE_COLS.length];
      for (int i = 0; i < TABLE_COLS.length; i++) {
        this.TABLE_COL_WIDTHS[i] = this.TABLE_COLS[i].length() * 24;
      }
    }

    initialize();
  }

  /**
   * 初期化
   */
  private void initialize() {
    createComposit();
    createItems();
    createMenu();
  }

  /**
   * Composit作成
   */
  protected void createComposit() {
    if (this.comp == null) {
      this.comp = createNRow1ColComposit();
    }
  }

  /**
   * 項目作成
   */
  protected void createItems() {
    createTable();
  }

  /**
   * テーブル作成
   */
  private void createTable() {
    if (table == null) {
      table = addSimpleTable(this.comp, TABLE_COLS, TABLE_COL_WIDTHS);
      setCmdToTableOnDoubleClick(this.table, "edit");
      cmdUpdate();
      // cmdSel_change();
    }
  }

  /**
   * 一覧更新
   */
  public void cmdUpdate() {
    this.table.removeAll();
    DBManager.findByAllToSwtTable(this.table, this.masterCls, this.TABLE_ROW_COLS);
    DBCacheManager.clear();
  }

  /**
   * メニュー作成
   */
  protected void createMenu() {
    create1LayerMenu(MENU_LABELS, MENU_CMDS, MENU_ACC);
  }

  /**
   * 編集
   */
  public void cmdEdit() {
    int id = ChkConvSwt.getSelectId(this.table);
    PBSwt window = new PBMasterEditSwt("edit", masterCls, id);
    window.show();
    cmdUpdate();
  }

  /**
   * 新規追加
   */
  public void cmdAdd() {
    PBSwt window = new PBMasterEditSwt("add", masterCls);
    window.show();
    cmdUpdate();
  }

  /**
   * 選択行削除
   */
  public void cmdDel() {
    int[] ids = ChkConvSwt.getSelectIds(this.table);
    if (MsgSwt.confirm("remove " + ids.length + " items ? ")) {
      for (int i = 0; i < ids.length; i++) {
        DBManager.removeByPrimaryKey(this.masterCls, ids[i]);
      }
      cmdUpdate();
    }
  }
  
  public void cmdCopy() {
    this.copyIds = ChkConvSwt.getSelectIds(this.table);
  }
  
  public void cmdPaste() {
    if (this.copyIds == null) {
      return;
    }
    
    for (int i = 0; i < this.copyIds.length; i++) {
      Object src_obj = DBManager.findByPrimaryKey(this.masterCls, copyIds[i]);
      DBManager.insert(src_obj);
    }
    cmdUpdate();
  }
}
