/**
 * WebSukui
 * copyright PowerBEANS Co., Ltd.
 * create date 2006/10/05
 * amonden
 */
package jp.co.powerbeans.websukui.swt;

import jp.co.powerbeans.common.db.DBManager;
import jp.co.powerbeans.common.swt.ChkConvSwt;
import jp.co.powerbeans.common.swt.MsgSwt;
import jp.co.powerbeans.websukui.Msg;
import jp.co.powerbeans.websukui.model.Customer;
import jp.co.powerbeans.websukui.model.MailConfig;
import jp.co.powerbeans.websukui.model.SendMailHistory;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Text;

/**
 * SendMailConfirmSwt
 * @author amonden
 * @create date 2006/10/05
 */
public class SendMailConfirmSwt extends PBSwt implements SendMailStatusListener {

  private SendMailConfirmType type;
  private Text toText;
  private MailConfig account;
  private Customer[] customers;
  private Text fromText;
  private Text ccText;
  private Text bccText;
  private Text subjectText;
  private Text bodyText;
  private Button sendButton;
  private Text logText;
  private Combo sendHistCombo;

  /**
   * @param customers 
   * @param account 
   */
  public SendMailConfirmSwt(SendMailConfirmType type, MailConfig account, Customer[] customers) {
    super();
    createSShell("Send mail confirm", 600, 620, true);
    
    this.type = type;
    this.account = account;
    this.customers = customers;
    
    initialize();

  }
  /**
   * 初期化
   */
  private void initialize() {
    createComposit();
    createItems();
    updateButtons();
  }

  /**
   * Composit作成
   */
  protected void createComposit() {
    setGridLayout(1);
  }

  /**
   * 項目作成
   */
  protected void createItems() {

//    // １行目 FROM
//    this.fromText = addLabelTextOrgRow(Msg.getFrom(), "fromText");
//    
    
    // １行目 送信履歴コンボ
    this.sendHistCombo = addLabelComboByModelOrgRow(Msg.getSendedHistory(),"sendHistCombo", SendMailHistory.class, "subject", "sendHistChange");
    
    if (type == SendMailConfirmType.TEST) {
      // ２行目 TO 
      this.toText = addLabelTextOrgRow(Msg.getTo(), "toText");
      this.toText.setText(this.account.getMailEmail());
    }
    
    // ３行目 CC
    this.ccText = addLabelTextOrgRow(Msg.getCc(), "ccText");
    
    // ４行目 BCC
    this.bccText = addLabelTextOrgRow(Msg.getBcc(), "bccText");
    
    // ５行目 件名
    this.subjectText = addLabelTextOrgRow(Msg.getSubject(), "subjectText");
    
    // ６行目 本文
    addLabel_left(Msg.getBody());
    this.bodyText = addTextBoxMulti("bodyText", 1, 300);
    
    // 送信ボタン
    this.sendButton = addSimpleButton_Left(Msg.getSend(), "send");
    
    // ログテキスト
    this.logText = addTextBoxMultiReadOnly("logText", 1, 100);
  }
  
  /**
   * 選択済みテーブルのデータによってボタンの状態を変更する
   */
  private void updateButtons() {
//    boolean sendable = this.selectTable.getItemCount() > 0;
//    this.sendTestButton.setEnabled(sendable);
//    this.sendButton.setEnabled(sendable);
  }
  
  public void cmdSendHistChange() {
    // 選択値を反映
    SendMailHistory his = (SendMailHistory) ChkConvSwt.getSelectObject(this.sendHistCombo);
    this.ccText.setText(his.getCc());
    this.bccText.setText(his.getBcc());
    this.subjectText.setText(his.getSubject());
    this.bodyText.setText(his.getBody());
  }

  public void cmdSend() {
    this.sendButton.setEnabled(false);
    this.logText.setText("");
    
    // 送信履歴に追加
    {
      SendMailHistory his = new SendMailHistory();
      his.setSubject(this.subjectText.getText());
      his.setBody(this.bodyText.getText());
      his.setCc(this.ccText.getText());
      his.setBcc(this.bccText.getText());
      DBManager.insert(his);
    }

    // テストモードでは画面のTOへのみ送信
    String to = this.toText == null ? this.account.getMailEmail() : this.toText.getText();
    try {
      type.send(this.account, this.customers, to, this.ccText.getText(), this.bccText.getText(), 
          this.subjectText.getText(), this.bodyText.getText(), this);
    } catch (Exception e) {
      onSendExption(e);
    }
    
    this.sendButton.setEnabled(true);
    
    MsgSwt.info(Msg.getSendedAll());
  }
  /**
   * @param e
   */
  private void onSendExption(Exception e) {
    e.printStackTrace();
    logText.append("Error: " + e.getMessage());
  }
  /* (non-Javadoc)
   * @see jp.co.powerbeans.websukui.swt.SendMailStatusListener#onSend(int, int)
   */
  public void onSend(int sended_num, int all_num) {
    logText.append("sended " + sended_num + " / " + all_num + "\r\n");
  }
}
