/**
 * WebSukui
 * copyright PowerBEANS Co., Ltd.
 * create date 2006/10/05
 * amonden
 */
package jp.co.powerbeans.websukui.swt;

import jp.co.powerbeans.common.db.DBManager;
import jp.co.powerbeans.common.db.DBUtil;
import jp.co.powerbeans.common.swt.ChkConvSwt;
import jp.co.powerbeans.common.swt.MsgSwt;
import jp.co.powerbeans.websukui.Msg;
import jp.co.powerbeans.websukui.model.Customer;
import jp.co.powerbeans.websukui.model.CustomerGrp;
import jp.co.powerbeans.websukui.model.MailConfig;

import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Table;

/**
 * SendMailSwt
 * @author amonden
 * @create date 2006/10/05
 */
public class SendMailSwt extends PBSwt {



  private static final String[] SEL_COLS = {"customerId", "name","companyName", "email"};
  private static final int[] SEL_WIDS = {50,200,200,300};
  private static final String[] TABLE_COLS = {"customerId", "name","companyName", "email"};
  private static final int[] TABLE_COL_WIDTHS = {50,200,200,300};
  private Table selectTable;
  private Table table;
  private Combo mailAccountCombo;
  private Combo customerGropCombo;
  private Button sendTestButton;
  private Button sendButton;

  /**
   */
  public SendMailSwt() {
    super();
    createSShell("Send mail wizard", true);
    
    initialize();

  }
  /**
   * 初期化
   */
  private void initialize() {
    createComposit();
    createItems();
    updateButtons();
  }

  /**
   * Composit作成
   */
  protected void createComposit() {
//    if (this.comp == null) {
//      this.comp = createNRow3ColComposit();
//    }
    setGridLayout(2);
  }

  /**
   * 項目作成
   */
  protected void createItems() {
    
    // 1行目アカウント選択
    this.mailAccountCombo = addLabelComboByModelOrgRow(Msg.getSendAccount(), "accountCombo",
        MailConfig.class, "mailName", "accountComboChange");
    if (this.mailAccountCombo.getItemCount() == 0) {
      MsgSwt.warn(Msg.getAddAccountBeforeSendMail());
      super.cmdCancel();
      return;
    }
    this.mailAccountCombo.select(0);

    // 2行目フィルタ
    this.customerGropCombo = addLabelComboByModelOrgRow(Msg.getGroup(), "customerGropCombo",
        CustomerGrp.class, "groupName", "customerGropComboChange");
    
    // 3行目送信先候補
    addLabel_left(Msg.getToCand());
    addSimpleButton(Msg.getSelect(), "toDown");
    createTable();

    // 4行目送信先候補
    addLabel_left(Msg.getSelectedTo());
    addSimpleButton(Msg.getClearSelect(), "toUp");
    createSelectTable();
    
    // テスト,送信ボタン
    this.sendTestButton = addSimpleButton(Msg.getToConfirmText(), "sendTest");
    this.sendButton = addSimpleButton(Msg.getToConfirm(), "send");
  }

  /**
   * テーブル作成
   */
  private void createTable() {
    if (table == null) {
      table = addSimpleTable(TABLE_COLS, TABLE_COL_WIDTHS, 2, 200);
      cmdCustomerGropComboChange();
    }
  }
  /**
   * 選択済みテーブル作成
   */
  private void createSelectTable() {
    if (this.selectTable == null) {
      this.selectTable = addSimpleTable(SEL_COLS, SEL_WIDS, 2, 200);
    }
  }
  
  /**
   * 右の選択テーブルで選択している行を削除
   */
  private void selectTableToTable() {
    ChkConvSwt.addSelectItem(this.selectTable, this.table);
    ChkConvSwt.deleteSelectItem(this.selectTable);
//    dialogChanged();
  }

  /**
   * 左テーブルを右の選択テーブルに追加
   */
  private void tableToSelectTable() {
    ChkConvSwt.addSelectItem(this.table, this.selectTable);
    ChkConvSwt.deleteSelectItem(this.table);
//    dialogChanged();
  }
  
  /**
   * 
   */
  public void cmdToUp() {
    selectTableToTable();
    updateButtons();
  }
  
  /**
   * 
   */
  public void cmdToDown() {
    tableToSelectTable();
    updateButtons();
  }
  
  public void cmdAccountComboChange() {
    // 処理無し
  }
  
  public void cmdCustomerGropComboChange() {
    // データ更新
    String where = (this.customerGropCombo.getSelectionIndex() == -1) ? "" : "customerGrpId = "
        + ChkConvSwt.getSelectObjectPK(this.customerGropCombo);
 
    this.table.removeAll();
    DBManager.findByToSwtTable(this.table, Customer.class, TABLE_COLS, where);
  }
  
  
  /**
   * 送信画面表示
   */
  public void cmdSendTest(SendMailConfirmType type) {
    MailConfig config = (MailConfig) ChkConvSwt.getSelectObject(this.mailAccountCombo);
    Customer[] customers = (Customer[]) DBUtil.swtTableToModels(this.selectTable, TABLE_COLS, Customer.class);
    SendMailConfirmSwt send = new SendMailConfirmSwt(type, config, customers);
    send.show();
  }
  
  /**
   * 送信テスト
   */
  public void cmdSendTest() {
    cmdSendTest(SendMailConfirmType.TEST);
  }
  
  /**
   * 送信
   */
  public void cmdSend() {
    cmdSendTest(SendMailConfirmType.OFFICIAL);
  }
  
  /**
   * 選択済みテーブルのデータによってボタンの状態を変更する
   */
  private void updateButtons() {
    boolean sendable = this.selectTable.getItemCount() > 0;
    this.sendTestButton.setEnabled(sendable);
    this.sendButton.setEnabled(sendable);
  }

}
